<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_graph_user_kernel_pytiovx_uc.py Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_graph_user_kernel_pytiovx_uc.py</h1><a href="vx__tutorial__graph__user__kernel__pytiovx__uc_8py.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a><a class="code" href="namespacevx__tutorial__graph__user__kernel__pytiovx__uc.html">00001</a> <span class="comment">#</span>
<a name="l00002"></a>00002 <span class="comment"># Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00003"></a>00003 <span class="comment">#</span>
<a name="l00004"></a>00004 <span class="comment"># All rights reserved not granted herein.</span>
<a name="l00005"></a>00005 <span class="comment">#</span>
<a name="l00006"></a>00006 <span class="comment"># Limited License.</span>
<a name="l00007"></a>00007 <span class="comment">#</span>
<a name="l00008"></a>00008 <span class="comment"># Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00009"></a>00009 <span class="comment"># license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00010"></a>00010 <span class="comment"># have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00011"></a>00011 <span class="comment"># terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00012"></a>00012 <span class="comment"># solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00013"></a>00013 <span class="comment"># The patent license shall not apply to any combinations which include this software,</span>
<a name="l00014"></a>00014 <span class="comment"># other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00015"></a>00015 <span class="comment"># No hardware patent is licensed hereunder.</span>
<a name="l00016"></a>00016 <span class="comment">#</span>
<a name="l00017"></a>00017 <span class="comment"># Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00018"></a>00018 <span class="comment"># (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00019"></a>00019 <span class="comment"># code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00020"></a>00020 <span class="comment"># with the distribution</span>
<a name="l00021"></a>00021 <span class="comment">#</span>
<a name="l00022"></a>00022 <span class="comment"># Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00023"></a>00023 <span class="comment"># that the following conditions are met:</span>
<a name="l00024"></a>00024 <span class="comment">#</span>
<a name="l00025"></a>00025 <span class="comment">#       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00026"></a>00026 <span class="comment"># permitted with respect to any software provided in binary form.</span>
<a name="l00027"></a>00027 <span class="comment">#</span>
<a name="l00028"></a>00028 <span class="comment">#       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00029"></a>00029 <span class="comment">#</span>
<a name="l00030"></a>00030 <span class="comment">#       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00031"></a>00031 <span class="comment"># licensed and provided to you in object code.</span>
<a name="l00032"></a>00032 <span class="comment">#</span>
<a name="l00033"></a>00033 <span class="comment"># If software source code is provided to you, modification and redistribution of the</span>
<a name="l00034"></a>00034 <span class="comment"># source code are permitted provided that the following conditions are met:</span>
<a name="l00035"></a>00035 <span class="comment">#</span>
<a name="l00036"></a>00036 <span class="comment">#       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00037"></a>00037 <span class="comment"># works, are licensed by TI for use only with TI Devices.</span>
<a name="l00038"></a>00038 <span class="comment">#</span>
<a name="l00039"></a>00039 <span class="comment">#       any redistribution and use of any object code compiled from the source code</span>
<a name="l00040"></a>00040 <span class="comment"># and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00041"></a>00041 <span class="comment">#</span>
<a name="l00042"></a>00042 <span class="comment"># Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00043"></a>00043 <span class="comment">#</span>
<a name="l00044"></a>00044 <span class="comment"># may be used to endorse or promote products derived from this software without</span>
<a name="l00045"></a>00045 <span class="comment"># specific prior written permission.</span>
<a name="l00046"></a>00046 <span class="comment">#</span>
<a name="l00047"></a>00047 <span class="comment"># DISCLAIMER.</span>
<a name="l00048"></a>00048 <span class="comment">#</span>
<a name="l00049"></a>00049 <span class="comment"># THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00050"></a>00050 <span class="comment"># OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00051"></a>00051 <span class="comment"># OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00052"></a>00052 <span class="comment"># IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00053"></a>00053 <span class="comment"># INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00054"></a>00054 <span class="comment"># BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00055"></a>00055 <span class="comment"># DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00056"></a>00056 <span class="comment"># OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00057"></a>00057 <span class="comment"># OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00058"></a>00058 <span class="comment"># OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00059"></a>00059 <span class="comment">#</span>
<a name="l00060"></a>00060 <span class="comment">#</span>
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="comment">## \file vx_tutorial_graph_user_kernel_pytiovx_uc.py This file show example of using basic PyTIOVX APIs to</span>
<a name="l00063"></a>00063 <span class="comment">#       describe user/target kernel class and use it within an OpenVX graph.</span>
<a name="l00064"></a>00064 <span class="comment">#</span>
<a name="l00065"></a>00065 <span class="comment"># See vx_tutorial_graph_image_gradients_pytiovx_uc.py for basic API usage.</span>
<a name="l00066"></a>00066 <span class="comment">#</span>
<a name="l00067"></a>00067 <span class="comment"># The basic steps to define user/target class and use it with PyTIOVX tool</span>
<a name="l00068"></a>00068 <span class="comment">#  - Define a class for user/target kernel dervied from tiovx::node::Node base class</span>
<a name="l00069"></a>00069 <span class="comment">#  - Overide the constructor to explicitly specific the parameters and types</span>
<a name="l00070"></a>00070 <span class="comment">#    - This allows the python to do basic syntax checking</span>
<a name="l00071"></a>00071 <span class="comment">#  - Overide the checkParams method to specify additional parameter checking if required</span>
<a name="l00072"></a>00072 <span class="comment">#  - Write the OpenVX use-case using PyTIOVX APIs</span>
<a name="l00073"></a>00073 <span class="comment">#    - Use the user/target class when adding the user/target kernel to the graph</span>
<a name="l00074"></a>00074 <span class="comment">#  - Export the graph as C code or .jpg file</span>
<a name="l00075"></a>00075 <span class="comment">#</span>
<a name="l00076"></a>00076 <span class="comment"># See source code of function vx_tutorial_graph_user_kernel_pytiovx_uc.make_my_graph() for detailed API usage for this example.</span>
<a name="l00077"></a>00077 <span class="comment">#</span>
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="keyword">from</span> tiovx <span class="keyword">import</span> *
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">## Class to represent user/target kernel</span>
<a name="l00082"></a>00082 <span class="comment">#</span>
<a name="l00083"></a>00083 <span class="comment"># Dervied from tiovx::node::Node base class</span>
<a name="l00084"></a><a class="code" href="classvx__tutorial__graph__user__kernel__pytiovx__uc_1_1NodePhaseRgb.html">00084</a> <span class="keyword">class </span><a class="code" href="classvx__tutorial__graph__user__kernel__pytiovx__uc_1_1NodePhaseRgb.html" title="Class to represent user/target kernel.">NodePhaseRgb</a> (<a class="code" href="classNode.html">Node</a>) :
<a name="l00085"></a>00085     <span class="comment">## Constructor for user/target kernel class</span>
<a name="l00086"></a>00086     <span class="comment">#</span>
<a name="l00087"></a>00087     <span class="comment">#  \param image_in [in] Input image handle parameter for this function</span>
<a name="l00088"></a>00088     <span class="comment">#  \param image_out [in] Output image handle parameter for this function</span>
<a name="l00089"></a>00089     <span class="comment">#  \param name [in] user indetifiable name</span>
<a name="l00090"></a>00090     <span class="comment">#  \param target [in] target CPU on which this kernel/node will run</span>
<a name="l00091"></a><a class="code" href="classvx__tutorial__graph__user__kernel__pytiovx__uc_1_1NodePhaseRgb.html#af7a2946aaf85a15ded46a2d116807632">00091</a>     <span class="keyword">def </span><a class="code" href="classvx__tutorial__graph__user__kernel__pytiovx__uc_1_1NodePhaseRgb.html#af7a2946aaf85a15ded46a2d116807632" title="Constructor for user/target kernel class.">__init__</a>(self, image_in, image_out, name=&quot;default&quot;, target=Target.DEFAULT) :
<a name="l00092"></a>00092         Node.__init__(self, <span class="stringliteral">&quot;vx_tutorial_graph.phase_rgb&quot;</span>, image_in, image_out)
<a name="l00093"></a>00093         self.setParams(1, 1, Type.IMAGE, Type.IMAGE)
<a name="l00094"></a>00094         self.setTarget(target)
<a name="l00095"></a>00095         self.setKernelEnumName(<span class="stringliteral">&quot;VX_USER_KERNEL&quot;</span>)
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="comment">## Parameter checking function</span>
<a name="l00098"></a>00098     <span class="comment">#</span>
<a name="l00099"></a>00099     <span class="comment">#  Checks if number of parameters passed is correct</span>
<a name="l00100"></a>00100     <span class="comment">#  Checks if data type of parameters passed is correct</span>
<a name="l00101"></a>00101     <span class="comment">#</span>
<a name="l00102"></a>00102     <span class="comment">#  \param param_type_args [in] Variable number of args list of type tiovx.enums.Type to specify data object types</span>
<a name="l00103"></a><a class="code" href="classvx__tutorial__graph__user__kernel__pytiovx__uc_1_1NodePhaseRgb.html#a05fd81cb8bdada3ad51416a471082af0">00103</a>     <span class="keyword">def </span><a class="code" href="classvx__tutorial__graph__user__kernel__pytiovx__uc_1_1NodePhaseRgb.html#a05fd81cb8bdada3ad51416a471082af0" title="Parameter checking function.">checkParams</a>(self, *param_type_args) :
<a name="l00104"></a>00104         <span class="comment"># invoke base class checker function</span>
<a name="l00105"></a>00105         Node.checkParams(self, *param_type_args)
<a name="l00106"></a>00106         <span class="comment"># additional error conditions over the basic ones</span>
<a name="l00107"></a>00107         <span class="keyword">assert</span> ( self.ref[0].width    == self.ref[1].width ), <span class="stringliteral">&quot;Input and Output width MUST match&quot;</span>
<a name="l00108"></a>00108         <span class="keyword">assert</span> ( self.ref[0].height   == self.ref[1].height ), <span class="stringliteral">&quot;Input and Output height MUST match&quot;</span>
<a name="l00109"></a>00109         <span class="keyword">assert</span> ( self.ref[0].df_image == DfImage.U8 ), <span class="stringliteral">&quot;Input data format must be U8&quot;</span>
<a name="l00110"></a>00110         <span class="keyword">assert</span> ( self.ref[1].df_image == DfImage.RGB ), <span class="stringliteral">&quot;Output data format must be RGB&quot;</span>
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="comment">## Function to describe a graph and generate code, image using PyTIOVX tool</span>
<a name="l00113"></a><a class="code" href="namespacevx__tutorial__graph__user__kernel__pytiovx__uc.html#a517d0f0ce7c6031f510ccbc591e569a3">00113</a> <span class="keyword">def </span><a class="code" href="namespacevx__tutorial__graph__user__kernel__pytiovx__uc.html#a517d0f0ce7c6031f510ccbc591e569a3" title="Function to describe a graph and generate code, image using PyTIOVX tool.">make_my_graph</a>() :
<a name="l00114"></a>00114     <span class="comment">## Create a context object.</span>
<a name="l00115"></a>00115     context = Context(<span class="stringliteral">&quot;vx_tutorial_graph_user_kernel_pytiovx_uc&quot;</span>)
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="comment">## Create a graph object.</span>
<a name="l00118"></a>00118     graph = Graph()
<a name="l00119"></a>00119 
<a name="l00120"></a>00120     <span class="comment">## local variables to define the with and height of input image</span>
<a name="l00121"></a>00121     width = 640
<a name="l00122"></a>00122     <span class="comment">## local variables to define the with and height of input image</span>
<a name="l00123"></a>00123     height = 480
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="comment">## Create input image object.</span>
<a name="l00126"></a>00126     in_image = Image(width, height, DfImage.U8, name=<span class="stringliteral">&quot;input&quot;</span>)
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     <span class="comment">## Create grad_x image object.</span>
<a name="l00129"></a>00129     grad_x = Image(width, height, DfImage.S16, name=<span class="stringliteral">&quot;grad_x&quot;</span>)
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="comment">## Create grad_y image object.</span>
<a name="l00132"></a>00132     grad_y = Image(width, height, DfImage.S16, name=<span class="stringliteral">&quot;grad_y&quot;</span>)
<a name="l00133"></a>00133 
<a name="l00134"></a>00134     <span class="comment">## Create phase image object.</span>
<a name="l00135"></a>00135     phase = Image(width, height, DfImage.U8, name=<span class="stringliteral">&quot;phase&quot;</span>)
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="comment">## Create 24b rgb object to represent phase.</span>
<a name="l00138"></a>00138     phase_rgb = Image(width, height, DfImage.RGB, name=<span class="stringliteral">&quot;phase_rgb&quot;</span>)
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <span class="comment">## Create and add node to graph for Sobel3x3</span>
<a name="l00141"></a>00141     graph.add ( NodeSobel3x3(in_image, grad_x, grad_y, target=Target.DSP1) )
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     <span class="comment">## Create and add node to graph for Phase</span>
<a name="l00144"></a>00144     graph.add ( NodePhase(grad_x, grad_y, phase, target=Target.DSP1) )
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="comment">## Create and add node to graph for user/target kernel</span>
<a name="l00147"></a>00147     graph.add ( NodePhaseRgb(phase, phase_rgb, target=Target.DSP1) )
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="comment">## Add graph to context</span>
<a name="l00150"></a>00150     context.add ( graph )
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <span class="comment">## Generate .jpg using &apos;dot&apos; tool to generate visual representation of graphs in this context</span>
<a name="l00153"></a>00153     ExportImage(context).export()
<a name="l00154"></a>00154     <span class="comment">## Generate C code to create, run, delete graphs in this context</span>
<a name="l00155"></a>00155     ExportCode(context).export()
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 make_my_graph()
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
